SystemOrganization addCategory: #MethodAuthorship!

OrderedCollection subclass: #MethodCollection
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodAuthorship'!

!MethodCollection class methodsFor: 'as yet unclassified' stamp: 'apb 10/17/2007 16:57'!
titled: aName
	^self new title: aName! !

!MethodCollection methodsFor: 'accessing' stamp: 'apb 10/17/2007 18:14'!
printOn: aStream 
	aStream nextPutAll: 'methods by ';
		 nextPutAll: title;
		 cr.
	self do: [:each | aStream tab; nextPutAll: each stringVersion; cr]! !

!MethodCollection methodsFor: 'accessing' stamp: 'apb 10/17/2007 16:56'!
title
	^ title! !

!MethodCollection methodsFor: 'accessing' stamp: 'apb 10/17/2007 16:56'!
title: aName 
	title := aName! !

Object subclass: #Authorship
	instanceVariableNames: 'authorDictionary'
	classVariableNames: 'AllMethods'
	poolDictionaries: ''
	category: 'MethodAuthorship'!

!Authorship class methodsFor: 'as yet unclassified' stamp: 'apb 10/17/2007 17:03'!
initialize
	super initialize.
	AllMethods
		ifNil: [AllMethods := OrderedCollection new.
			ProtoObject
				withAllSubclassesDo: [:eachClass | eachClass selectors
						do: [:eachSelector | AllMethods
								add: (MethodReference class: eachClass selector: eachSelector)]]]! !

!Authorship methodsFor: 'private' stamp: 'apb 10/17/2007 14:09'!
addToListIfAuthorIsMissingSignatory: each 
	"author dictionary's value at key k is an OrderedCollection containing the methods 
	written by k"
	(authorDictionary at: each author ifAbsent: [^self]) addLast: each! !

!Authorship methodsFor: 'initialize-release' stamp: 'apb 10/17/2007 17:01'!
initialize
	
	authorDictionary := Dictionary new.
	self missingSignatories
		pairsDo: [:initials :name | authorDictionary
				at: initials
				put: (MethodCollection titled: name)].
	AllMethods
		do: [:each | self addToListIfAuthorIsMissingSignatory: each]! !

!Authorship methodsFor: 'filtering' stamp: 'apb 10/17/2007 16:59'!
missingAuthorsWithMethods
	^ authorDictionary select: [ :eachAssoc | eachAssoc value notEmpty ]! !

!Authorship methodsFor: 'data' stamp: 'apb 10/17/2007 14:12'!
missingSignatories
"From http://www.netjam.org/squeak/contributors/missingSignatories"

"This is a list of all Squeak contributors who have not returned a signed distribution agreement.

26 July 2007, 3:59:54 pm pacific time

116 missing signatories

---

initials         name"
^ #(
'abc'              '?'
'ac'               'Andres Coratella'
'acg'              'Andrew C. Greenberg'
'AFi'              'Alain Fischer'
'afr'              'Alejandro Reimondo'
'ag'               'Andrew Gaylard?'
'AK'               'Anoulak Kictiraz'
'AM'               'Aibek Musaev'
'aoy'              'Andres Otaduy'
'ASF'              '?'
'BEO'              'Bernd Oldenbuettel'
'BJP'              'Bijan Parsia'
'bmk'              'Brian Keefer'
'bolot'            'Bolot Kerimbaev'
'BP'               'Bijan Parsia'
'bvs'              'Ben Schroeder'
'ccn+ceg'          'Chris Norton and Carl Gundel'
'cE'               '?'
'cm'               '?'
'de'               '?'
'djm'              'Douglas McPherson'
'djp'              'David J. Pennell'
'dls'              '?'
'dns'              'David N. Smith'
'drs'              '?'
'dwh'              'Dwight Hughes'
'eat'              'Eric Arseneau Tremblay'
'edt'              '?'
'eldeh'            'Lars Dornheim'
'em'               'Ernest Micklei?'
'emm'              'Ernest Micklei'
'EP'               '?'
'EW'               '?'
'ff'               'Felix Franz'
'gg'               'Giovanni Giorgi'
'GL'               '?'
'GVG'              'Greg Gritton'
'gwc'              'Geoff Corey'
'H.Hachisuka'      'Hitoshi Hachisuka'
'HEG'              'Henrik Ekenberg'
'hg'               'Henrik Gedenryd'
'hh'               'Helge Horch'
'HJH'              'Hannes Hirzel'
'IT'               '?'
'jbc'              'Jay Casler'
'JDD'              'John David Duncan'
'jdl'              '?'
'jet'              'John Tobler'
'jj'               '?'
'jla'              'Jerry Archibald'
'JLM'              'Joshua Marker'
'JP'               '?'
'jsp'              'Jeff Pierce'
'JW'               'Jesse Welton'
'jwh'              'Jim Heyne'
'JWS'              'John Sarkela'
'JZH'              'John (Zhijiang) Han'
'Kafka'            'Pablo Malavolta'
'KTT'              'Kurt Thams'
'LEG'              'Gerald Leeb'
'len'              'Luciano Esteban Notarfrancesco'
'los'              'Lothar Schenk'
'm'                '?'
'MAL'              'Michael Latta'
'mdr'              'Mike Rutenberg'
'mkd'              'Michael Donegan'
'MM'               'marca?'
'mm'               '?'
'mn'               'Mats Nygren'
'MPH'              'Michael Hewner'
'msk'              'Michael Klein'
'mx'               'Maximialiano Taborda'
'NDCC'             '?'
'nm'               'Norberto Manzanos'
'nop'              'Jay Carlson'
'panda'            '?'
'PH'               'Phil Hudson'
'PHK'              'Peter Keeler'
'pmm'              '?'
'pnm'              'Paul McDonough'
'programmatic'     '?'
'r++'              'Gerardo Richarte'
'RAH'              'Richard A. Harmon'
'RB'               'Roland Bertuli'
'RCS'              'Russell Swan'
'reThink'          'John Sarkela'
'RJ'               'Ranjan Bagchi'
'rjf'              'Ricardo J. Ferreira'
'rlf'              '?'
'RMF'              'Robert Fure'
'rop'              'Russell Penney'
'rpj'              'Robert P. Jarvis'
'RvL'              'Reinier van Loon'
'sac'              'Scott Crosby'
'Sames'            'Samuel S. Shuster'
'SIM'              '?'
'sjc'              '?'
'sk'               '?'
'slr'              '?'
'squeak'           '?'
'SSS'              'Samuel S. Shuster'
'sws'              '?'
'TAG'              'Travis Griggs'
'TBP'              '?'
'TEM'              'Tom Morgan'
'tfei'             'The Fourth Estate, Inc.'
'tm'               '?'
'to'               '?'
'tp'               '?'
'ts'               'Torsten Sadowski'
'umur'             'Umur Ozkul'
'ward'             'Ward Cunningham'
'wb'               'Wayne Braun'
'wdc'              'Bill Cattey'
'YE'               '?'
'zL'               'Lantz Rowland'
)! !

!Authorship methodsFor: 'filtering' stamp: 'apb 10/17/2007 18:31'!
printMissingAuthors
	| f |
	f := StandardFileStream forceNewFileNamed: 'MethodsOfMissingSignatories.txt'.
	self missingAuthorsWithMethods associations asSortedCollection do:
		[: assoc | 
			f nextPutAll: assoc key;   nextPutAll: ': '.
			assoc value printOn: f].
	f close! !

!CompiledMethod methodsFor: '*methodAuthorship' stamp: 'apb 10/17/2007 12:41'!
author
	"Answer the author's initials"
	"(CompiledMethod >> #author) author"
	^ self timeStamp copyUpTo: $ .
	! !

!MethodReference methodsFor: '*methodAuthorship' stamp: 'apb 10/17/2007 14:15'!
author
	^ self compiledMethod author! !
Authorship initialize!
